#ifndef __filed_h
#define __filed_h

#include "parse.h"
#include "/usr/local/mysql/include/mysql.h"
#include <time.h>
#include <unistd.h>

struct session {
	char *session_id;
	int session_seq;
	time_t create;
	time_t last_access;
	short flags;
	struct session *prev;
	struct session *next;
};

struct connection {
	struct queue *in;
	struct queue *out;
	struct queue *err;
	int flags;
	int type;
	int id;
	int fd;
	time_t last_recv;
	time_t last_msg;
	time_t first_msg;
	char name[32];
	char remote_addr[20];
	struct connection *prev;
	struct connection *next;
	/* peer only data */
	short pflags;
	int load;
	int s_count;
	/* human data only */
	int debug_mask;
};

#include "shmem.h"

struct db {
	int id;
	int filter;
	int seq;
	int loc;
	short flags;

	char *query;
	char *output;
	struct db *prev;
	struct db *next;
};

struct filed {
	/* main handles */

	int main_fd;
	int shmid;

	/* sequences */

	int id;
	int dbid;
	int session_id;
	int request_id;

	/* stats related info */

	int spin;
	time_t last_hb;
	int run;
	int load;
	int s_count;
	short peer_flags;
	pid_t db_pid;
	int best_peer; /* the seq of the best peer, 0 if not there */

	/* other */

	char conf_file[256];
	char hostname[20]; /* our name */

	/* structs */

	struct connection *con_head;
	struct parse_hdr *cf;
	struct db *db;
	struct session *session;
	struct msg *msg; /* IPC communication channel */
	struct todel *todel;
};	

#endif
