#include "queue.h"
#include "filed.h"
#include "log.h"
#include "main.h"
#include "externs.h"
#include <malloc.h>
#include <string.h>

struct queue *ins_queue(struct queue *q, char *data, short flags) {
	struct queue *ret;
	struct queue *head;
	head = q;
	
	dlog(DEBUG_CODE,"ins_queue(): [%s] %d",data,flags);

	if(!(ret = (struct queue *) malloc(sizeof(struct queue)))) {
		elog("ins_queue() malloc failed");
		die();
	}
	ret->prev = NULL;
	ret->next = NULL;
	if(data) {
		ret->data = strdup(data);
		ret->len = strlen(data);
	} else {
		ret->data = NULL;
		ret->len = 0;
	}

	ret->offset = 0;	
	ret->flags = flags;

	if(!q) return(ret);

	while(q->next) q = q->next;
	q->next = ret;
	ret->prev = q;
	return(head);
}

struct queue *rm_queue(struct queue *head, struct queue *rm) {
	struct queue *ret;
	struct queue *q;
	
	if(rm == head) {
		if(head->next) ret = head->next;
		else
		ret = NULL;

		if(ret) ret->prev = NULL;
		free(head->data);
		free(head);
		return(ret);
	}

	q = head;

	while(q) {
		if(q == rm) {
			if(q->prev) q->prev->next = q->next;
			if(q->next) q->next->prev = q->prev;
			free(q->data);
			free(q);
			return(head);
		}
	q = q->next;
	}

	return(NULL);
}


struct queue *get_tail(struct queue *queue) {
	struct queue *ret = queue;
	
	if(!queue) return(NULL);
	while(ret->next) ret = ret->next;
	return(ret);
}

void free_queue(struct queue *queue) {
	struct queue *q;
	struct queue *r;
	
	q = queue;

	while(q) {
		r = q;
		q = q->next;
		if(r->data) free(r->data);
		free(r);
	}

	return;
}
